﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SweetSurvey.Models.Repositories
{
    public interface IQuestionRepository: IRepository<Question, string>
    {
        IQueryable<Question> GetSampleQuestions();
        IQueryable<Question> GetQuestionsBySurveyId(string surveyId);
        void MoveUp(string id);
        void MoveDown(string id);
        bool ValidateSequence(string surveyId, IList<string> questionIds);
        void DeleteQuestionsBySurveyId(string surveyId);
    }
}
